// Appendable.hpp

#ifndef BRYNHILD_CORE_APPENDABLE_HPP
#define BRYNHILD_CORE_APPENDABLE_HPP

#include <string>
#include <stdexcept>

namespace brynhild {
namespace core {

class Appendable {
public:
    virtual ~Appendable() {}

    // Append a string or a part of it
    virtual Appendable& append(const std::string& csq, int start = 0, int end = -1) = 0;

    // Append a single character
    virtual Appendable& append(char c) = 0;
};

} // namespace core
} // namespace brynhild

#endif // BRYNHILD_CORE_APPENDABLE_HPP
