#include<iostream>
#include<vector>
#include<fstream>
#include<cstring>
#include<sstream>
using namespace std;
namespace brynhild {
    namespace core {
        class Tokenizer {
        private:
            size_t currentLine;
            size_t currentPos;

        public:
            std::string lastWord;
            std::vector<std::string> lines;
            bool isEOF;
            Tokenizer(const std::string& filename)
                : currentLine(1), currentPos(1), isEOF(false) {
                std::ifstream file(filename);
                if (!file.is_open()) {
                    throw std::runtime_error("Could not open file");
                }
                std::string line;
                while (std::getline(file, line)) {
                    lines.push_back(line);
                }
                file.close();
            }

            bool getNextWord(std::string& word) {
                if (isEOF) return false;
                while (currentLine <= lines.size()) {
                    while (currentPos <= lines[currentLine - 1].length() && lines[currentLine - 1][currentPos - 1] == ' ') {
                        currentPos++;
                    }
                    size_t startPos = currentPos;
                    while (currentPos <= lines[currentLine - 1].length() && lines[currentLine - 1][currentPos - 1] != ' ') {
                        currentPos++;
                    }
                    if (startPos < currentPos) {
                        word = lines[currentLine - 1].substr(startPos - 1, currentPos - startPos);
                        lastWord = word;
                        return true;
                    }
                    currentLine++;
                    currentPos = 1;
                }
                isEOF = true;
                lastWord = "";
                return false;
            }


            size_t getCurrentLine() const {
                return currentLine;
            }

            size_t getCurrentOffset() const {
                return currentPos;
            }
        };
    }
}
